//
//  ArtworkAnimator.m
//  NowPlayingSaver
//
//  Created by Juri Pakaste on 20.10.09.
//  Copyright (c) 2009, Juri Pakaste. All rights reserved.
//  For licensing details see the file COPYING.
//

#import "ArtworkAnimator.h"

#import "NSImage+CGImageRefAdditions.h"

#import <QuartzCore/QuartzCore.h>

@implementation ArtworkAnimator

-(void)animateArtworkLayer:(CALayer*)layer toArtwork:(NSImage*)image
{
    [CATransaction begin];
    [CATransaction setDisableActions:YES];
    layer.anchorPoint = CGPointMake(0.5, 0.5);
    layer.position = CGPointMake(CGRectGetMidX(layer.bounds), CGRectGetMidY(layer.bounds));
    [CATransaction commit];
    
    CGImageRef newImage = [image createAspectFitCGImageSized:layer.bounds.size];
    
    [self performArtworkAnimationInLayer:layer toArtwork:newImage];
}


-(void)performArtworkAnimationInLayer:(CALayer*)layer toArtwork:(CGImageRef)image
{
    NSLog(@"performArtworkAnimationInLayer:toArtwork: not implemented");
}


@end
