//
//  CADebug.m
//  NowPlayingSaver
//
//  Created by Juri Pakaste on 21.9.09.
//  Copyright (c) 2009, Juri Pakaste. All rights reserved.
//  For licensing details see the file COPYING.
//

#import "CADebug.h"


NSString* cat2s(CATransform3D t)
{
	return [NSString stringWithFormat:@"[\n\t%0.2f %0.2f %0.2f %0.2f\n\t%0.2f %0.2f %0.2f %0.2f\n\t%0.2f %0.2f %0.2f %0.2f\n\t%0.2f %0.2f %0.2f %0.2f\n]",
			t.m11, t.m12, t.m13, t.m14,
			t.m21, t.m22, t.m23, t.m24,
			t.m31, t.m32, t.m33, t.m34,
			t.m41, t.m42, t.m43, t.m44];
}

NSString* NSStringFromCGPoint(CGPoint p)
{
	return [NSString stringWithFormat:@"(%0.1f, %0.1f)", p.x, p.y];
}

NSString* NSStringFromCGSize(CGSize s)
{
	return [NSString stringWithFormat:@"%0.1f x %0.1f", s.width, s.height];
}


NSString* NSStringFromCGRect(CGRect r)
{
	return [NSString stringWithFormat:@"%@ %@", NSStringFromCGSize(r.size), NSStringFromCGPoint(r.origin)];
}


@implementation CALayer (Debug)
-(NSString*)description
{
	return [NSString stringWithFormat:@"<%@ %p bounds:%@ position:%@ anchorPoint:%@>", [self class], self, NSStringFromCGRect(self.bounds), NSStringFromCGPoint(self.position), NSStringFromCGPoint(self.anchorPoint)];
}
@end
