//
//  NSImage+CGImageRefAdditions.m
//  NowPlayingSaver
//
//  Created by Juri Pakaste on 17.10.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "NSImage+CGImageRefAdditions.h"

@implementation NSImage (CGImageRefAdditions)

-(CGImageRef)createAspectFitCGImageSized:(CGSize)size
{
    CGSize is = self.size;
    CGFloat width = size.width;
    CGFloat height = is.height * (width / is.width);
    
    if (height > size.height)
    {
        height = size.height;
        width = is.width * (height / is.height);
    }
    
    CGContextRef bitmapCtx = CGBitmapContextCreate(NULL/*data - pass NULL to let CG allocate the memory*/, 
                                                   width,  
                                                   height,
                                                   8 /*bitsPerComponent*/, 
                                                   0 /*bytesPerRow - CG will calculate it for you if it's allocating the data.  This might get padded out a bit for better alignment*/, 
                                                   [[NSColorSpace genericRGBColorSpace] CGColorSpace], 
                                                   kCGBitmapByteOrder32Host|kCGImageAlphaPremultipliedFirst);
    
    [NSGraphicsContext saveGraphicsState];
    [NSGraphicsContext setCurrentContext:[NSGraphicsContext graphicsContextWithGraphicsPort:bitmapCtx flipped:NO]];
    [self drawInRect:NSMakeRect(0,0, width, height) fromRect:NSZeroRect/*sentinel, means "the whole thing*/ operation:NSCompositeCopy fraction:1.0];
    [NSGraphicsContext restoreGraphicsState];
    
    CGImageRef newImage = CGBitmapContextCreateImage(bitmapCtx);
    CGContextRelease(bitmapCtx);
    
    return (CGImageRef)[NSMakeCollectable(newImage) autorelease];
}

@end
