//
//  NSObject+BlockAdditions.m
//  NowPlayingSaver
//
//  Created by Juri Pakaste on 5.10.09.
//  Copyright (c) 2009, Juri Pakaste. All rights reserved.
//  For licensing details see the file COPYING.
//

#import "NSObject+BlockAdditions.h"

@interface NSObjectBlockCaller : NSObject {
@private
    void (^mBlock)(id ob);
}

-(id)initWithBlock:(void(^)(id ob))block;
-(void)performCallFrom:(id)ob;

@end


@implementation NSObjectBlockCaller

-(id)initWithBlock:(void (^)(id))block
{
    if ((self = [super init]))
    {
        mBlock = block;
    }
    return self;
}

-(void)performCallFrom:(id)ob
{
    mBlock(ob);
}

@end



@implementation NSObject (BlockAdditions)

-(void)performAfterDelay:(NSTimeInterval)delay block:(void(^)(id ob))block
{
    NSObjectBlockCaller* c = [[NSObjectBlockCaller alloc] initWithBlock:block];
    [c performSelector:@selector(performCallFrom:) withObject:self afterDelay:delay];
    [[NSGarbageCollector defaultCollector] disableCollectorForPointer:c];
}


@end
