//
//  RunnerAppDelegate.m
//  NowPlayingSaver
//
//  Created by Juri Pakaste on 19.9.09.
//  Copyright (c) 2009, Juri Pakaste. All rights reserved.
//  For licensing details see the file COPYING.
//

#import "RunnerAppDelegate.h"

#import "ElementProvider.h"
#import "NowPlayingSaverView.h"
#import "NSObject+BlockAdditions.h"

@interface RunnerAppDelegate ()

@property (retain, nonatomic) NowPlayingSaverView* saver;

@end



@implementation RunnerAppDelegate

-(void)applicationDidFinishLaunching:(NSNotification *)notification
{
	NSView* cview = self.window.contentView;
	self.saver = [[NowPlayingSaverView alloc] initWithFrame:cview.bounds isPreview:NO];
	[cview addSubview:self.saver];
	if ([[[NSProcessInfo processInfo] arguments] containsObject:@"noitunes"])
	{
		self.saver.elementProvider = [[SequentialElementProvider alloc] initWithElements:self.saver.elementProvider.elements];
		NowPlayingInfo* info = [[NowPlayingInfo alloc] init];
		info.albumName = @"fake album";
		info.artistName = @"fake artist";
		info.trackName = @"fake track";
		info.artwork = [NSImage imageNamed:@"cover1.png"];
		[self.saver showFakeInfo:info];
		[self.saver performAfterDelay:7 block:[^(id ob) {
			NSLog(@"--------------------------------------------------------------------------------");
			NowPlayingInfo* i2 = [[NowPlayingInfo alloc] init];
			i2.albumName = @"another fake album";
			i2.artistName = @"another fake artist";
			i2.trackName = @"another fake track";
			i2.artwork = [NSImage imageNamed:@"cover2.png"];
			[ob showFakeInfo:i2];
		} copy]];
	}
	else
	{
		[self.saver startAnimation];
	}
}


@synthesize saver;
@synthesize window;

@end
